# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "ib-shell"
version = "0.2.0"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A library for Windows Shell."
readme = "README.md"
keywords = [
    "file",
    "shell",
    "desktop-environment",
    "desktop",
    "hook",
]
categories = [
    "gui",
    "os",
]
license = "MIT"
repository = "https://github.com/Chaoses-Ib/ib-shell"

[package.metadata.docs.rs]
targets = ["x86_64-pc-windows-msvc"]
all-features = true
rustdoc-args = [
    "--cfg",
    "docsrs",
]

[features]
bin = [
    "dep:clap",
    "dep:ctrlc",
    "dep:tracing-subscriber",
]
default = ["item"]
doc = ["dep:document-features"]
everything = ["ib-shell-item?/everything"]
hook = [
    "dep:ib-hook",
    "ib-shell-item?/hook",
    "ib-shell-verb?/hook",
]
hook-dll = [
    "ib-hook/inject-dll",
    "ib-hook/inject-dll-dll",
    "ib-hook/sysinfo",
    "ib-shell-item?/hook-dll",
]
hook-log = ["ib-shell-item?/hook-log"]
item = [
    "dep:ib-shell-item",
    "ib-shell-item/prop",
]
verb = ["dep:ib-shell-verb"]

[lib]
name = "ib_shell"
path = "src/lib.rs"

[[bin]]
name = "inject-hook"
path = "src/bin/inject-hook.rs"
required-features = [
    "hook",
    "hook-dll",
    "bin",
]

[[example]]
name = "hook"
crate-type = ["cdylib"]
path = "examples/hook.rs"

[dependencies.anyhow]
version = "1"

[dependencies.bon]
version = "3"

[dependencies.clap]
version = "4"
features = ["derive"]
optional = true

[dependencies.ctrlc]
version = "3"
features = ["termination"]
optional = true

[dependencies.document-features]
version = "0.2"
optional = true

[dependencies.ib-hook]
version = "0.2"
features = ["tracing"]
optional = true

[dependencies.ib-shell-item]
version = "0.2"
optional = true

[dependencies.ib-shell-verb]
version = "0.1"
optional = true

[dependencies.serde]
version = "1"
features = ["derive"]

[dependencies.tracing]
version = "0.1"

[dependencies.tracing-subscriber]
version = "0.3"
optional = true

[dependencies.widestring]
version = "1"

[dev-dependencies]

[target.'cfg(target_family = "windows")'.dependencies.windows]
version = "0.62"
features = []
